#ifndef TX_COMMON_H
#define TX_COMMON_H

#include <cstddef>
#include <stdio.h>
#include <iostream>
#include <algorithm> // std::min
#include <cuda.h>
#ifdef CUSP_USE_TEXTURE_MEMORY
#include <cusp/detail/device/texture.h>
#endif
#include <cusp/detail/device/arch.h>
#include <cusp/detail/device/common.h>
#include <cusp/detail/device/utils.h>

#if THRUST_VERSION >= 100500
#include <thrust/detail/backend/cuda/arch.h>
using namespace thrust::detail::backend::cuda::arch;
#else
#include <thrust/detail/device/cuda/arch.h>
using namespace thrust::detail::device::cuda::arch;
#endif

#define DIVIDE_INTO(x,y) ((x + y - 1)/y)

template<typename value_type>
class Equals {
 public:
  __device__ value_type operator() (value_type a, value_type b) {
    return b;
  }
};

template<typename value_type>
class PlusEquals {
 public:
  __device__ value_type operator() (value_type a, value_type b) {
    return a+b;
  }
};

#endif // TX_COMMON_H
